#!/usr/bin/perl

use warnings;
use strict;

use Digest::SHA1  qw(sha1_hex);

# Download CryptoPhoto Perl lib from https://cryptophoto.com/admin/api
use CryptoPhotoUtils;
use CGI;

my $server      = "https://cryptophoto.com";
my $private_key = "xxx"; # Your CryptoPhoto Private API Key
my $public_key  = "yyy"; # Your CryptoPhoto Public API Key
my $salt        = "random-salt-string";
my $uid         = "userId"; # Your users internal ID
my $tvkey       = "key-of-a-transaction-verification-template"; # see https://cryptophoto.com/info/cptv-templates

my $cgi = CGI->new();
my $_POST = $cgi->Vars();

my $display = '';

if (exists $_POST->{'message'} && exists $_POST->{'message'}) {
  if (exists $_POST->{'cpJWSrfc7515'} && exists $_POST->{'cpTVresponse'}) {

    my $cp = new CryptoPhotoUtils($server, $private_key, $public_key, sha1_hex($uid.$salt));
    my $response = $cp->verify_cptv_response($_POST);

    if ($response->{'is_valid'}) {# response validate
      # do something with form values based on $_POST->{'cpTVresponse'} which
      # contains the response from the transaction
      $display = '<p>Message sent and received: '.$_POST->{'cpTVresponse'}.'</p>';
    } else {
      $display = '<p>' . $response->{'error'} . '</p>';
    }
  }
}

my $cp = new CryptoPhotoUtils($server, $private_key, $public_key, sha1_hex($uid.$salt));
my $response = $cp->start_session($ENV{'REMOTE_ADDR'});

my $sid;

if ($response->{'is_valid'}) {
  $sid = $response->{'sid'};
} else {
  $display .= '<p>' .
      $response->{'error'} . ( $response->{'errdesc'} ? ' ' . $response->{'errdesc'} : '' ) .
    '</p>';
}
 
$display .= '<form action="" method="post">' .
          'Message: <input type="type" name="message"><br>' . 
	  '<input type="submit" value="Send">' . 
	  '</form>';
 
if ($sid) {
  $display .= "<script type='text/javascript' src='".$server."/api/tv?key=".$tvkey."&sid=".$sid."' async='true'></script>";
}
 
my $out=<<HTML;
Content-Type: text/html; charset=utf-8

<!DOCTYPE html>
<html>
<head>
<meta charset="UTF-8">
<title>Send Message</title>
</head>
<body style="text-align:center">
  <h2>Send Message</h2>
  $display
</body>
</html>
HTML

print $out;